const express = require('express');

const xml = require('js2xmlparser');

const cityApp = express();

const libs = `${process.cwd()}/libs`;

const log = require(`${libs}/log`)(module);

const dbQuery = require(`${libs}/db/query_exec`);

function response(req, res) {
    if (req.query.format === 'csv') {
        res.csv(req.result);
    } else if (req.query.format === 'xml') {
        res.send(xml('result', JSON.stringify({ city: req.result })));
    } else {
        res.json({ result: req.result });
    }
}

cityApp.get('/', (req, res) => {
    const citySql = 'SELECT * FROM municipios';
    dbQuery(yearSql).then((result) => {
        req.result = result;
        return response(req, res);
    }, (error) => {
        log.error(`[${req.originalUrl}] SQL query error: ${error}`);
        next('Internal error, request could not be satisfied at this moment. Please, try again later');
    });
});

cityApp.get('/:id', (req, res) => {
    const citySql = 'SELECT * FROM municipios WHERE pk_municipio_id = ?';
    const cityId = parseInt(req.params.id, 10);
    dbQuery(citySql, [cityId]).then((result) => {
        req.result = result;
        return response(req, res);
    }, (error) => {
        log.error(`[${req.originalUrl}] SQL query error: ${error}`);
        next('Internal error, request could not be satisfied at this moment. Please, try again later');
    });
});

cityApp.get('/ibge/:id', (req, res) => {
    const citySql = 'SELECT * FROM municipios WHERE codigo_ibge = ?';
    const cityIbgeCode = req.params.id;
    dbQuery(citySql, [cityIbgeCode]).then((result) => {
        req.result = result;
        return response(req, res);
    }, (error) => {
        log.error(`[${req.originalUrl}] SQL query error: ${error}`);
        next('Internal error, request could not be satisfied at this moment. Please, try again later');
    });
});

cityApp.get('/state/:id', (req, res) => {
    const citySql = 'SELECT * FROM municipios WHERE fk_estado_id = ?';
    const stateId = parseInt(req.params.id, 10);
    dbQuery(citySql, [stateId]).then((result) => {
        req.result = result;
        return response(req, res);
    }, (error) => {
        log.error(`[${req.originalUrl}] SQL query error: ${error}`);
        next('Internal error, request could not be satisfied at this moment. Please, try again later');
    });
});

module.exports = cityApp;
